/*

Copyright 2016 Kai Nagel

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "helpertc.h"

helperTC::helperTC()
{

}

QString helperTC::frame2tc(int frame, int fps)
{
    int FramesInt = frame % fps;
    QString FramesStr = QString::number(FramesInt);
    if (FramesStr.length() == 1)
    {
        FramesStr = "0" + FramesStr;
    }

    frame -= FramesInt;

    int SecondsInt = (frame / fps) % 60;
    QString SecondsStr = QString::number(SecondsInt);
    if (SecondsStr.length() == 1)
    {
        SecondsStr = "0" + SecondsStr;
    }

    frame -= SecondsInt * fps;

    int MinutesInt = (frame / (60 * fps)) % 60;
    QString MinutesStr = QString::number(MinutesInt);
    if (MinutesStr.length() == 1)
    {
        MinutesStr = "0" + MinutesStr;
    }

    frame -= MinutesInt * 60 * fps;

    int HoursInt = (frame / (60 * 60 * fps)) % 60;
    QString HoursStr = QString::number(HoursInt);
    if (HoursStr.length() == 1)
    {
        HoursStr = "0" + HoursStr;
    }

    return(HoursStr + ":" + MinutesStr + ":" + SecondsStr + ":" + FramesStr);
}

QString helperTC::ms2mstc(int ms)
{
    int msInt = ms % 1000;
    QString msStr = QString::number(msInt);
    if (msStr.length() == 1)
    {
        msStr = "00" + msStr;
    }
    if (msStr.length() == 2)
    {
        msStr = "0" + msStr;
    }

    ms -= msInt;

    int SecondsInt = (ms / 1000) % 60;
    QString SecondsStr = QString::number(SecondsInt);
    if (SecondsStr.length() == 1)
    {
        SecondsStr = "0" + SecondsStr;
    }

    ms -= SecondsInt * 1000;

    int MinutesInt = (ms / (60 * 1000)) % 60;
    QString MinutesStr = QString::number(MinutesInt);
    if (MinutesStr.length() == 1)
    {
        MinutesStr = "0" + MinutesStr;
    }

    ms -= MinutesInt * 60 * 1000;

    int HoursInt = (ms / (60 * 60 * 1000)) % 60;
    QString HoursStr = QString::number(HoursInt);
    if (HoursStr.length() == 1)
    {
        HoursStr = "0" + HoursStr;
    }

    return(HoursStr + ":" + MinutesStr + ":" + SecondsStr + "," + msStr);
}

QString helperTC::dcp2mstc(QString DCPtc, int msOffset)
{
    QString h = DCPtc;
    QString m = DCPtc;
    QString s = DCPtc;
    QString b = DCPtc;

    h.truncate(2);
    m.truncate(5);
    m.remove(0,3);
    s.truncate(8);
    s.remove(0,6);
    b.remove(0,9);

    int ms = b.toInt()*4 + s.toInt()*1000 + m.toInt()*60000 + h.toInt()*3600000 + msOffset;

    return(ms2mstc(ms));
}
