/*

Copyright 2016 Kai Nagel

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "xmlpackinglist.h"

/*xmlPackingList::xmlPackingList()
{

}*/

int xmlPackingList::getCplCount() {

    int counter=0;

    for (int i = 0; i < AssetList.size(); ++i) {
        xmlAsset asset = AssetList[i];
        if (asset.Type == "text/xml;asdcpKind=CPL") {
            counter++;
        }
    }
    return(counter);
}

QString xmlPackingList::getCplFilenameText(int j) {

    if (j > getCplCount()) return("");

    int counter=0;
    QString ret="";

    for (int i = 0; i < AssetList.size(); ++i) {
        xmlAsset asset = AssetList[i];
        if (asset.Type == "text/xml;asdcpKind=CPL") {
            counter++;
            if (counter == j) ret = asset.OriginalFileName;
        }
    }
    return(ret);
}

QString xmlPackingList::getCplAnnotationOrFilenameText(int j) {

    if (j > getCplCount()) return("");

    int counter=0;
    QString ret="";

    for (int i = 0; i < AssetList.size(); ++i) {
        xmlAsset asset = AssetList[i];
        if (asset.Type == "text/xml;asdcpKind=CPL") {
            counter++;
            if (counter == j) ret = asset.AnnotationText;
            if (ret == "") ret = asset.OriginalFileName;
        }
    }
    return(ret);
}

void xmlPackingList::reset()
{
    AssetList.clear();
}

void xmlPackingList::openFile(QString filename)
{
    xmlFile.setFileName(filename);
    xmlFile.open(QIODevice::ReadOnly);
    xml.setDevice(&xmlFile);
    xml.readNextStartElement();
}

void xmlPackingList::read(){
    //    qDebug() << "PackingList read aufgerufen!";

    while (!xml.atEnd() && !xml.hasError())
    {
        if (!xml.readNextStartElement())
        {
            break;
        }

        if (xml.name() == "Id")
        {
            Id = xml.readElementText();
        }
        else if (xml.name() == "AnnotationText")
        {
            AnnotationText = xml.readElementText();
        }
        else if (xml.name() == "IssueDate")
        {
            IssueDate = xml.readElementText();
        }
        else if (xml.name() == "Issuer")
        {
            Issuer = xml.readElementText();
        }
        else if (xml.name() == "Creator")
        {
            Creator = xml.readElementText();
        }
        else if (xml.name() == "AssetList")
        {
            //            qDebug() << "AssetList reached.";
            while (!xml.atEnd() && !xml.hasError())
            {
                if (!xml.readNextStartElement())
                {
                    break;
                }

                if (xml.name() == "Asset")
                {
                    xmlAsset newAsset;
                    if (! newAsset.read(xml))
                    {
                        qDebug() << "Reached document end or aborted";
                        return;
                    }

                    AssetList.append(newAsset);
                }
                else
                {
                    qDebug() << "ERROR: unexpected element:" << xml.name();
                    return;
                }
            }
        }
        else if (xml.name() == "Signer")
        {

        }
        else if (xml.name() == "X509Data")
        {

        }
        else if (xml.name() == "X509IssuerSerial")
        {

        }
        else if (xml.name() == "X509IssuerName")
        {

        }
        else
        {
            qDebug() << "ERROR: unexpected element:" << xml.name();
        }
    }
    xmlFile.close();
}



// -------------------------------------------------------------------------------------------------

bool xmlPackingList::xmlAsset::read(QXmlStreamReader& xml)
{
    Q_ASSERT(xml.name() == "Asset");

    while (!xml.atEnd() && !xml.hasError())
    {
        if (!xml.readNextStartElement())
        {
            break;
        }

        if (xml.name() == "Id")
        {
            Id = xml.readElementText();
        }
        else if (xml.name() == "AnnotationText")
        {
            AnnotationText = xml.readElementText();
        }
        else if (xml.name() == "Hash")
        {
            Hash = xml.readElementText();
        }
        else if (xml.name() == "Size")
        {
            Size = xml.readElementText().toInt();
        }
        else if (xml.name() == "Type")
        {
            Type = xml.readElementText();
        }
        else if (xml.name() == "OriginalFileName")
        {
            OriginalFileName = xml.readElementText();
        }
        else
        {
            qDebug() << "ERROR: unexpected chunk element:" << xml.name();
            return false;
        }
    }

    return true;
}

