/*

Copyright 2016 Kai Nagel

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef XMLPACKINGLIST_H
#define XMLPACKINGLIST_H

#include <QFile>
#include <QXmlStreamReader>
#include <QDebug>
#include <QString>
#include <QList>

class xmlPackingList
{
public:
    class xmlAsset;

    void reset();
    void openFile(QString filename);
    void read();

    int getCplCount();
    QString getCplFilenameText(int);
    QString getCplAnnotationOrFilenameText(int);


    //    const QList<xmlAsset>& getAssetList() const;

    class xmlAsset
    {
    public:
        bool read(QXmlStreamReader& stream);

        QString Id;
        QString AnnotationText;
        QString Hash;
        int Size;
        QString Type;
        QString OriginalFileName;
    };


private:
    QXmlStreamReader xml;
    QFile xmlFile;

    QString Id;
    QString AnnotationText;
    QString IssueDate;
    QString Issuer;
    QString Creator;
    QList<xmlAsset> AssetList;
};

#endif // XMLPACKINGLIST_H
