#ifndef XMLTEST_H
#define XMLTEST_H

#include <QMainWindow>
#include <QMessageBox>
#include <QFileDialog>
#include <QDebug>
/*

Copyright 2016 Kai Nagel

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <QString>
#include <QList>
#include <QStandardPaths>
#include <QDesktopServices>
#include <QUrl>
#include "xmlassetmap.h"
#include "xmlpackinglist.h"
#include "xmlcplist.h"
#include "helpertc.h"
#include "ui_about.h"
#include "ui_reportError.h"

#define Version "Version: 0.1 Beta"

namespace Ui {
class XmlTest;
}

class XmlTest : public QMainWindow
{
    Q_OBJECT

public:
    explicit XmlTest(QWidget *parent = 0);
    ~XmlTest();

private:
    Ui::XmlTest *ui;

    QMessageBox msgBox;
    QString BaseDir;
    QString ExportFilename;
    xmlPackingList pkl;
    xmlCplist cpl;
    QList<xmlAssetmap::xmlAsset> AssetList;

    helperTC TC;

private slots:
    void on_pushButtonOpen_clicked();
    void on_comboBoxChooseCpl_currentIndexChanged();
    void on_pushButtonSave_clicked();
    void on_actionAbout_triggered();
    void on_actionReport_an_error_triggered();
    void on_actionCheck_for_updates_triggered();
};

#endif // XMLTEST_H
